

Cc: Nikita Danilov <nikita@clusterfs.com>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 fs/proc/proc_misc.c |    1 -
 mm/page_alloc.c     |   17 ++++++++++-------
 2 files changed, 10 insertions(+), 8 deletions(-)

diff -puN fs/proc/proc_misc.c~mm-add-proc-zoneinfo-tidy fs/proc/proc_misc.c
--- 25/fs/proc/proc_misc.c~mm-add-proc-zoneinfo-tidy	2005-04-25 20:11:02.530797488 -0700
+++ 25-akpm/fs/proc/proc_misc.c	2005-04-25 20:11:02.536796576 -0700
@@ -222,7 +222,6 @@ static struct file_operations fragmentat
 extern struct seq_operations zoneinfo_op;
 static int zoneinfo_open(struct inode *inode, struct file *file)
 {
-	(void)inode;
 	return seq_open(file, &zoneinfo_op);
 }
 
diff -puN mm/page_alloc.c~mm-add-proc-zoneinfo-tidy mm/page_alloc.c
--- 25/mm/page_alloc.c~mm-add-proc-zoneinfo-tidy	2005-04-25 20:11:02.532797184 -0700
+++ 25-akpm/mm/page_alloc.c	2005-04-25 20:11:02.537796424 -0700
@@ -1845,12 +1845,12 @@ struct seq_operations fragmentation_op =
  */
 static int zoneinfo_show(struct seq_file *m, void *arg)
 {
-	pg_data_t *pgdat = (pg_data_t *)arg;
+	pg_data_t *pgdat = arg;
 	struct zone *zone;
 	struct zone *node_zones = pgdat->node_zones;
 	unsigned long flags;
 
-	for (zone = node_zones; zone - node_zones < MAX_NR_ZONES; ++zone) {
+	for (zone = node_zones; zone - node_zones < MAX_NR_ZONES; zone++) {
 		int i;
 
 		if (!zone->present_pages)
@@ -1881,20 +1881,23 @@ static int zoneinfo_show(struct seq_file
 		seq_printf(m,
 			   "\n        protection: (%lu",
 			   zone->lowmem_reserve[0]);
-		for (i = 1; i < ARRAY_SIZE(zone->lowmem_reserve); ++ i)
+		for (i = 1; i < ARRAY_SIZE(zone->lowmem_reserve); i++)
 			seq_printf(m, ", %lu", zone->lowmem_reserve[i]);
 		seq_printf(m,
 			   ")"
 			   "\n  pagesets");
-		for (i = 0; i < ARRAY_SIZE(zone->pageset); ++ i) {
+		for (i = 0; i < ARRAY_SIZE(zone->pageset); i++) {
 			struct per_cpu_pageset *pageset;
 			int j;
 
 			pageset = &zone->pageset[i];
-			if (pageset->pcp[0].count == 0 &&
-			    pageset->pcp[1].count == 0)
+			for (j = 0; j < ARRAY_SIZE(pageset->pcp); j++) {
+				if (pageset->pcp[j].count)
+					break;
+			}
+			if (j == ARRAY_SIZE(pageset->pcp))
 				continue;
-			for (j = 0; j < ARRAY_SIZE(pageset->pcp); ++ j) {
+			for (j = 0; j < ARRAY_SIZE(pageset->pcp); j++) {
 				seq_printf(m,
 					   "\n    cpu: %i pcp: %i"
 					   "\n              count: %i"
_
